module MicroBunny
  class Connection
    def initialize(adapter:, host:, vhost: nil, username: 'guest', password: 'guest')
      @conn = adapter.new(
        host,
        vhost: vhost,
        username: username,
        password: password,
        continuation_timeout: 10000
      )
      conn.start
    end

    def channel
      @channel ||= conn.create_channel
    end

    def stop
      conn.close
    end

    private
    attr_reader :conn
  end
end

