module MicroBunny
  class EventLookup
    def initialize(name)
      @name = name.is_a?(Symbol) ? camelize(name.to_s) : name
    end

    def event
      constantize(name + "Event")
    end

    def consumer
      constantize(name + "Consumer")
    end

    private
    attr_reader :name

    def camelize(string)
      string.split('_').map(&:capitalize).join
    end

    def constantize(string)
      Object.const_get(string)
    end
  end
end
