module MicroBunny
  class EventTrigger
    def initialize(channel, name, lookup = EventLookup)
      @event = lookup.new(name).event.new(channel)
    end

    def with(payload)
      @payload = payload
      self
    end

    def for(record)
      @record = record
      self
    end

    def broadcast
      record ? @event.trigger(payload, record) : @event.trigger(payload)
    end

    private
    attr_reader :channel, :event, :payload, :record
  end
end

