require_relative './subscriber'

module MicroBunny
  class Subscriptions
    def initialize(channel, topics, records, &block)
      @channel = channel
      @topics = topics
      @records = records
      @callback = block
    end

    def create
      all(topics).each do |topic|
        exchange = create_exchange(topic)
        sub = Subscriber.new(channel, exchange, callback)
        records.empty? ? sub.topic(topic) : sub.records(records)
      end
    end

    private

    attr_reader :channel, :topics, :records, :callback

    def all(topics)
      Array(topics).flatten.map(&:to_sym)
    end

    def create_exchange(topic)
      channel.topic(topic)
    end
  end
end

