require 'json'

module MicroBunny
  class Payload
    attr_accessor :event, :message, :record

    def self.deserialize(json)
      new JSON.parse(json, symbolize_names: true)
    end

    def initialize(event:, message:, record: nil)
      @event = event
      @message = message
      @record = record
    end

    def serialize
      {event: event, message: message, record: record}.to_json
    end
  end
end

